#include<stdlib.h>
#include<stdio.h>

struct list_element {
   int val;
   struct list_element * next;
   struct list_element * prev;
};

typedef struct list_element list_item;

void print_list(list_item *curr, int reverse){
   if(reverse) printf("NULL<-->");
   while(curr) {
      printf("%d", curr->val);
      curr = reverse?curr->prev:curr->next;
      if(curr) printf("<-->");
   }
   if(!reverse) printf("<-->NULL"); 
   printf("\n"); 
} 

int main() {
   list_item * curr, * head, *prev, *tail;
   int i;

   head = NULL;
   prev = NULL;
   tail = NULL;

   for(i=1;i<=10;i++) {
      curr = (list_item *)malloc(sizeof(list_item));
      curr->val = i;
   
      if(prev != NULL){
        prev->prev =curr;
      }else{
        tail = curr;
      }
   
      curr->prev  = NULL;
      curr->next  = head;
      head = curr;
      prev = curr;
   }

   printf("printing the doubly linked list using the next pointer starting from the head \n");
   print_list(head,0);
   printf("printing the doubly linked list using the prev pointer starting from the tail \n");
   print_list(tail,1);
   return 0;
}
